// シリアルポートを選んで接続
import controlP5.*;
import java.util.*;
import processing.serial.*;

ControlP5 cp5;
ScrollableList d1,d2;
Serial myPort = null;   // シリアルポート
List<String> portList;
int portX;
String portName;
int srSpd = 115200;    // シリアル通信速度
int rate[] = {9600,19200,38400,115200};

void setup() {
  size(450, 250);
  cp5 = new ControlP5(this);
  portList = Arrays.asList(Serial.list());
  //int portIndex = portList.size()-1;
  
  // ScrollableListの設定：( name, x, y, width, height )
  d1 = cp5.addScrollableList("prtLst",20,70,220,160)
       .setBarHeight(30)
       .setItemHeight(30)
       .addItems(portList)
     //.setValue(portIndex)
     ;

  d2 = cp5.addScrollableList("spdLst",300,70,120,150)
        .setItemHeight(30)
        .setBarHeight(30)
        ;
  for(int r:rate){ d2.addItem(str(r),r); }  // ポートリスト追加

  cp5.addTextfield("input",40,20,200,30)
     .setFocus(true)                // フォーカスがある時
     .setColor(color(255,255,0))    // 文字フォント色
     ;
  cp5.getController("input")       // inputの
     .getCaptionLabel()            // Captio.Lableの
     .align(ControlP5.LEFT_OUTSIDE,ControlP5.CENTER)
     .setPaddingX(0)               // 表示場所変更
     ;
}

void draw() {
  background(100);
}

void spdLst(int n){
  srSpd = rate[n];
  setPort();
}

void prtLst(int n) {
  portX = n;
  portName = portList.get(n);
  setPort();
}

void setPort(){
  // 既に接続されていれば、切断して、接続する
  if ( myPort != null ) myPort.stop();
//  myPort = new Serial(this, portList.get(portX), srSpd);
  myPort = new Serial(this, portName, srSpd);
//  println(portList.get(portX),srSpd);
    println(portName,srSpd);
}

void serialEvent(Serial myPort) {
  // 受信データがあれば、IDE コンソールに出力
  if ( myPort.available() > 0 ) {
    String str = myPort.readStringUntil('\n');
    if ( str != null ) print(str);
  }
}

void input (String theText){
  myPort.write(theText+"\n");
}
